/*******************************************************************************/
/*                                                                             */
/*   common.c :  uÓVwvLڂ̕@ɂVvZ̊{vZ֐            */
/*      Ver. 1.2    1999/07/02         By    takesako@mrj.biglobe.ne.jp        */
/*                                           (c)1999 Shinobu Takesako          */
/*******************************************************************************/

#include <stdio.h>
#include <math.h>

#include "jpl_eph.h"
 FILE *optr;

/*******************************************************************************/
/*                      EX̌vZ                                       */
/*                                                                             */
/*               gpԂnW(LST)ȂF LST=1                         */
/*               gpԂnώ(LMT)ȂF LST=0                         */
/*******************************************************************************/

double JD(double year,double month,double day,double hour,int LST,double longitude)
{
	double s,juday,a,flag;

	flag =1;
	if (longitude <0){ 
		longitude = -longitude;
		flag=-1;
		}

	if ( month < 3 ){
		year = year -1;
		month = month +12;
		};
	s = floor( 365.25 * year) + floor( 30.59 * (month-2.0));
	if (LST==1)
	{juday = s + day + hour/24.0 -  flag*floor(longitude /15.0+0.5)/24.0	+ 1721086.5;}
		else
		{juday = s + day + hour/24.0 -  flag*longitude /15.0/24.0	+ 1721086.5;}


	if ( juday > 2299150 ) {
		a = floor ( year / 400 ) - floor( year / 100)+2;
		juday = juday + a;
		};

	return(juday);
}
/*******************************************************************************/
/*                      ̌vZ                                             */
/*                                                                             */
/*               gpԂnW(LST)ȂF LST=1                         */
/*               gpԂnώ(LMT)ȂF LST=0                         */
/*******************************************************************************/

void Calendar( double juday, double *year,double *month,double *day,double *hour,int LST,double longitude)
{
	double flag,Z,Alfa,A,B,C,D,E,F,Day0;
	
	flag = 1;

	if (longitude<0 ){
		longitude = - longitude;
		flag=-1.0;
	}
	
	if (LST==1) juday =  juday +  flag*(double)(int)(longitude /15.0+0.5)/24.0;
		else    juday =  juday +  flag*longitude /15.0/24.0	;
		
	juday = juday + 0.5;
	Z = (double)(int)(juday);
	F = juday - Z;

	if (Z < 2299161.0) A = Z;
		else { 
			Alfa = (double)(int) ((Z - 1867216.25)/36524.25);
			A = Z + 1 + Alfa - (double)(int) (Alfa/4.0);}

	B = A + 1524;
	C = (double)(int) ((B-122.1)/365.25);
	D = (double)(int) (365.25 * C);
	E = (double)(int) ((B-D)/30.6001);

	Day0 = B - D - (double)(int)(30.60001*E) + F;
//	*day = (double)(int)(Day0);
//	*hour= F*24.0;
	*day = (double)(int)(Day0)+F;
	*hour=0.0;
	if(E<14.0) *month = E-1.0;
	if(E==14.0 || E==15.0)	 *month = E- 13.0;
	if(*month>2.0) *year=C-4716;
	if(*month==1.0 || *month==2.0) *year = C - 4715;


}
/*******************************************************************************/
/*                      tϐN̕                               */
/*******************************************************************************/

void DateToYMD(double Date,double *year,double *month,double *day)

{
	double flag,Year,Month;
	
	flag=0;
//	if(Date<0){Date1=(double)(int)(-Date);
//	hour=Date-Date1;
//	Date=-Date1/10000;
//	} else {
//	Date1=(double)(int)Date;
//	hour=Date-Date1;
//	Date=Date1/10000;
//	}
	Date=Date/10000;
	if (Date<0) {
		Date=-Date;
	    flag = 1;
	    };
	Year  = floor(Date);
	Month = floor((Date-Year)*100);
	*day  = (Date*10000-Year*10000-Month*100);
//	*day =*day+hour;
	*year = floor(Date);
	*month= Month;
	if(flag==1) *year = -*year;

}

/*******************************************************************************/
/*                      吔̂܂ߌvZ                                       */
/*******************************************************************************/

double Compact (double y, double x)
{
	y = x * ( y / x - floor (y / x));
	if((int)x==360 && y <0) y=y+360.0;
	return(y);
}


/*******************************************************************************/
/*                      QOOON̐ǏvZ                           */
/*******************************************************************************/

double T_2000 (double jd)
{
	double JD0=2451545.0 , t ;
	t=(jd-JD0)/(100.0*365.25);
	return t ;
}
/*******************************************************************************/
/*                      kršvZ                                           */
/*******************************************************************************/

double LST( double jd, double longitude)
{
	double t,lst;

	t=(jd-2451545.0)/36525.0;
	lst=280.46061837+360.98564736629*(jd-2451545.0)+(0.000387933-t/38710000)*t*t;
	lst=lst+longitude;
	lst = Compact(lst,360)/15.0;

	return lst;
}


/*******************************************************************************/
/*                      ԕb\玞Ԃւ̕ϊ                           */
/*******************************************************************************/

double HMSToHour(double HMS)
{
	int flag=0;
	double H,Hour,Min,Sec;
	
	if (HMS<0){
		flag=1;
		HMS=-HMS;
		};
	Hour  = floor(HMS);
	Min   = floor((HMS - Hour)*100);
	Sec   = (HMS*10000-Hour*10000-Min*100);
	H     = Hour + Min/60.0 +  Sec/3600.0;
    if(flag==1)H=-H;
	return H;
}

/*******************************************************************************/
/*                      ԕb\pxւ̕ϊ  ( 1999/07/01 ǉ )      */
/*******************************************************************************/

double HMSToDeg(double HMS)
{
	double H,Deg;
	
	H=HMSToHour( HMS);
	
	Deg = H*15.0;
	return Deg;
}

/*******************************************************************************/
/*                      xb\xւ̕ϊ                               */
/*******************************************************************************/

double DMSToDeg(double DMS)
{
	int flag=0;
	double D,Deg,Min,Sec;
	
	if (DMS<0){
		flag=1;
		DMS=-DMS;
		};
	Deg   = floor(DMS);
	Min   = floor((DMS - Deg)*100);
	if(Min>99.0){Min=Min-100;Deg=Deg+1;}
	Sec   = DMS*10000-Deg*10000-Min*100;
	if(Sec>99.0){Sec=Sec-100;Min=Min+1;}
	D     = Deg +  Min/60.0 +  Sec/3600.0;
	if(flag==1)D=-D;
    return D;
}
/*******************************************************************************/
/*                      _Oʂł̎ľܓ                               */
/*******************************************************************************/

double Digit3( double x)
{
	int flag=0;

	if(x<0){
		x=-x;
		flag=1;
	}
	x=(double)((int)(x*1000.0+0.5));
	x=x/1000.0;
	if(flag==1)x=-x;
	return x;

}
